## com.google.javascript.jscomp
Class PlovrCompilerOptions

    java.lang.Object
      com.google.javascript.jscomp.CompilerOptions
          com.google.javascript.jscomp.PlovrCompilerOptions

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class PlovrCompilerOptions

extends com.google.javascript.jscomp.CompilerOptions

`PlovrCompilerOptions` is a subclass of `CompilerOptions` with customizations for plovr. The need for the subclass is twofold:

1. It contains compiler options that are specific to plovr, such as `globalScopeName` (though admittedly, `globalScopeName` will go away soon in favor of the Compiler's built-in `RescopeGlobalSymbols` pass).
2. It provides public accessors to properties that are ordinarily package-private, which is helpful during unit-testing. (See `ConfigTest`).

Originally, these modifications were contained in plovr's local fork of `CompilerOptions`, but this often created merge conflicts when syncing plovr's Closure Compiler fork.

Author:
  bolinfest@gmail.com (Michael Bolin)
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.google.javascript.jscomp.CompilerOptions
`com.google.javascript.jscomp.CompilerOptions.AliasTransformation, com.google.javascript.jscomp.CompilerOptions.AliasTransformationHandler, com.google.javascript.jscomp.CompilerOptions.LanguageMode, com.google.javascript.jscomp.CompilerOptions.Reach, com.google.javascript.jscomp.CompilerOptions.TracerMode, com.google.javascript.jscomp.CompilerOptions.TweakProcessing`

Field Summary
`java.lang.String` `globalScopeName` The name of the scope to prefix all global variable assignments with.

Fields inherited from class com.google.javascript.jscomp.CompilerOptions

`aggressiveVarCheck, aliasableStrings, aliasAllStrings, aliasExternals, aliasKeywords, aliasStringsBlacklist, ambiguateProperties, anonymousFunctionNaming, brokenClosureRequiresLevel, checkControlStructures, checkGlobalNamesLevel, checkGlobalThisLevel, checkMissingGetCssNameBlacklist, checkMissingGetCssNameLevel, checkMissingReturn, checkProvides, checkRequires, checkSuspiciousCode, checkSymbols, checkTypes, checkUnreachableCode, closurePass, coalesceVariableNames, collapseAnonymousFunctions, collapseProperties, collapseVariableDeclarations, computeFunctionSideEffects, convertToDottedProperties, crossModuleCodeMotion, crossModuleMethodMotion, cssRenamingMap, customPasses, deadAssignmentElimination, devirtualizePrototypeMethods, disambiguateProperties, errorFormat, exportTestFunctions, extractPrototypeMemberDeclarations, flowSensitiveInlineVariables, foldConstants, gatherCssNames, generateExports, generatePseudoNames, ideMode, inlineConstantVars, inlineFunctions, inlineGetters, inlineLocalFunctions, inlineVariables, inputDelimiter, inputPropertyMapSerialized, inputVariableMapSerialized, instrumentationTemplate, jqueryPass, labelRenaming, lineBreak, locale, markAsCompiled, markNoSideEffectCalls, messageBundle, moveFunctionDeclarations, optimizeArgumentsArray, optimizeCalls, optimizeParameters, optimizeReturns, prettyPrint, printInputDelimiter, propertyRenaming, recordFunctionInformation, removeDeadCode, removeTryCatchFinally, removeUnusedLocalVars, removeUnusedPrototypeProperties, removeUnusedPrototypePropertiesInExterns, removeUnusedVars, renamePrefix, renamePrefixNamespace, reportMissingOverride, reserveRawExports, rewriteFunctionExpressions, smartNameRemoval, sourceMapDetailLevel, sourceMapFormat, sourceMapLocationMappings, sourceMapOutputPath, stripNamePrefixes, stripNameSuffixes, stripTypePrefixes, stripTypes, syntheticBlockEndMarker, syntheticBlockStartMarker, variableRenaming`

Constructor Summary
`PlovrCompilerOptions()`

Method Summary
`boolean` `getAcceptConstKeyword()`
`java.lang.String` `getOutputCharset()`
`boolean` `getProcessObjectPropertyString()`
`com.google.javascript.jscomp.CheckLevel` `getReportUnknownTypes()`

Methods inherited from class com.google.javascript.jscomp.CompilerOptions

`addWarningsGuard, assumeClosuresOnlyCaptureReferences, assumeStrictThis, clone, disableRuntimeTypeCheck, enableExternExports, enableRuntimeTypeCheck, getAliasTransformationHandler, getCodingConvention, getDefineReplacements, getInferTypes, getLanguageIn, getLanguageOut, getTweakProcessing, getTweakReplacements, isExternExportsEnabled, resetWarningsGuard, setAcceptConstKeyword, setAggressiveVarCheck, setAliasableGlobals, setAliasableStrings, setAliasAllStrings, setAliasExternals, setAliasKeywords, setAliasStringsBlacklist, setAliasTransformationHandler, setAmbiguateProperties, setAnonymousFunctionNaming, setAppNameStr, setAssumeClosuresOnlyCaptureReferences, setAssumeStrictThis, setBrokenClosureRequiresLevel, setChainCalls, setCheckCaja, setCheckControlStructures, setCheckGlobalNamesLevel, setCheckGlobalThisLevel, setCheckMissingGetCssNameBlacklist, setCheckMissingGetCssNameLevel, setCheckMissingReturn, setCheckProvides, setCheckRequires, setCheckSuspiciousCode, setCheckSymbols, setCheckTypes, setCheckUnreachableCode, setClosurePass, setCoalesceVariableNames, setCodingConvention, setCollapseAnonymousFunctions, setCollapseObjectLiterals, setCollapseProperties, setCollapsePropertiesOnExternTypes, setCollapseVariableDeclarations, setColorizeErrorOutput, setCommonJSModulePathPrefix, setComputeFunctionSideEffects, setConvertToDottedProperties, setCrossModuleCodeMotion, setCrossModuleMethodMotion, setCssRenamingMap, setCustomPasses, setDeadAssignmentElimination, setDebugFunctionSideEffectsPath, setDefineReplacements, setDefineToBooleanLiteral, setDefineToDoubleLiteral, setDefineToNumberLiteral, setDefineToStringLiteral, setDependencyOptions, setDevirtualizePrototypeMethods, setDevMode, setDisambiguateProperties, setErrorFormat, setExportTestFunctions, setExternExports, setExternExportsPath, setExtraAnnotationNames, setExtractPrototypeMemberDeclarations, setFlowSensitiveInlineVariables, setFoldConstants, setGatherCssNames, setGenerateExports, setGeneratePseudoNames, setGroupVariableDeclarations, setIdeMode, setIdGenerators, setIgnoreCajaProperties, setInferTypes, setInlineConstantVars, setInlineFunctions, setInlineFunctions, setInlineGetters, setInlineLocalFunctions, setInlineLocalVariables, setInlineVariables, setInlineVariables, setInputDelimiter, setInputPropertyMapSerialized, setInputVariableMapSerialized, setInstrumentationTemplate, setLabelRenaming, setLanguageIn, setLanguageOut, setLineBreak, setLineLengthThreshold, setLocale, setLooseTypes, setManageClosureDependencies, setManageClosureDependencies, setMarkAsCompiled, setMarkNoSideEffectCalls, setMessageBundle, setMoveFunctionDeclarations, setNameAnonymousFunctionsOnly, setNameReferenceGraphPath, setNameReferenceReportPath, setOptimizeArgumentsArray, setOptimizeCalls, setOptimizeParameters, setOptimizeReturns, setOutputCharset, setOutputJsStringUsage, setPrettyPrint, setPrintInputDelimiter, setProcessCommonJSModules, setProcessObjectPropertyString, setPropertyAffinity, setPropertyInvalidationErrors, setPropertyRenaming, setProtectHiddenSideEffects, setRecordFunctionInformation, setRemoveAbstractMethods, setRemoveClosureAsserts, setRemoveDeadCode, setRemoveTryCatchFinally, setRemoveUnusedLocalVars, setRemoveUnusedPrototypeProperties, setRemoveUnusedPrototypePropertiesInExterns, setRemoveUnusedVariable, setRemoveUnusedVariables, setRemoveUnusedVars, setRenamePrefix, setRenamePrefixNamespace, setRenamingPolicy, setReplaceIdGenerators, setReplaceStringsConfiguration, setReplaceStringsFunctionDescriptions, setReplaceStringsPlaceholderToken, setReplaceStringsReservedStrings, setReportMissingOverride, setReportPath, setReportUnknownTypes, setReserveRawExports, setRewriteFunctionExpressions, setRewriteNewDateGoogNow, setRuntimeTypeCheck, setRuntimeTypeCheckLogFunction, setShadowVariables, setSkipAllPasses, setSmartNameRemoval, setSourceMapDetailLevel, setSourceMapFormat, setSourceMapLocationMappings, setSourceMapOutputPath, setSpecializeInitialModule, setStripNamePrefixes, setStripNameSuffixes, setStripTypePrefixes, setStripTypes, setSummaryDetailLevel, setSyntheticBlockEndMarker, setSyntheticBlockStartMarker, setTightenTypes, setTracer, setTracerMode, setTransformAMDToCJSModules, setTweakProcessing, setTweakReplacements, setTweakToBooleanLiteral, setTweakToDoubleLiteral, setTweakToNumberLiteral, setTweakToStringLiteral, setUnaliasableGlobals, setVariableRenaming, setWarningLevel, setWarningsGuard, shouldColorizeErrorOutput, skipAllCompilerPasses`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### globalScopeName

    public java.lang.String globalScopeName

  The name of the scope to prefix all global variable assignments with. This assumes that all of the resulting code will be wrapped in a with (scope) { } wrapper.

Constructor Detail

### PlovrCompilerOptions

    public PlovrCompilerOptions()

Method Detail

### getProcessObjectPropertyString

    public boolean getProcessObjectPropertyString()

### getReportUnknownTypes

    public com.google.javascript.jscomp.CheckLevel getReportUnknownTypes()

### getAcceptConstKeyword

    public boolean getAcceptConstKeyword()

### getOutputCharset

    public java.lang.String getOutputCharset()